
;CodeVisionAVR C Compiler V3.10 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Release
;Chip type              : ATmega48
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': No
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: No
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega48
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x02FF
	.EQU __DSTACK_SIZE=0x0080
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_compa_isr
	RJMP _timer0_compb_isr
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_sinus:
	.DB  0x0,0x3,0x6,0x9,0xC,0x10,0x13,0x16
	.DB  0x19,0x1C,0x1F,0x22,0x25,0x28,0x2B,0x2E
	.DB  0x31,0x33,0x36,0x39,0x3C,0x3F,0x41,0x44
	.DB  0x47,0x49,0x4C,0x4E,0x51,0x53,0x55,0x58
	.DB  0x5A,0x5C,0x5E,0x60,0x62,0x64,0x66,0x68
	.DB  0x6A,0x6B,0x6D,0x6F,0x70,0x71,0x73,0x74
	.DB  0x75,0x76,0x78,0x79,0x7A,0x7A,0x7B,0x7C
	.DB  0x7D,0x7D,0x7E,0x7E,0x7E,0x7F,0x7F,0x7F
	.DB  0x7F,0x7F,0x7F,0x7F,0x7E,0x7E,0x7E,0x7D
	.DB  0x7D,0x7C,0x7B,0x7A,0x7A,0x79,0x78,0x76
	.DB  0x75,0x74,0x73,0x71,0x70,0x6F,0x6D,0x6B
	.DB  0x6A,0x68,0x66,0x64,0x62,0x60,0x5E,0x5C
	.DB  0x5A,0x58,0x55,0x53,0x51,0x4E,0x4C,0x49
	.DB  0x47,0x44,0x41,0x3F,0x3C,0x39,0x36,0x33
	.DB  0x31,0x2E,0x2B,0x28,0x25,0x22,0x1F,0x1C
	.DB  0x19,0x16,0x13,0x10,0xC,0x9,0x6,0x3
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  0x1
_0x4:
	.DB  0x1
_0x5:
	.DB  0x1
_0x6:
	.DB  0x1
_0x7:
	.DB  0x5E,0x1

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _pol_a
	.DW  _0x3*2

	.DW  0x01
	.DW  _pol_b
	.DW  _0x4*2

	.DW  0x01
	.DW  _index_bc_calc
	.DW  _0x5*2

	.DW  0x01
	.DW  _inc_ind
	.DW  _0x6*2

	.DW  0x02
	.DW  _freq_int
	.DW  _0x7*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x180

	.CSEG
;/*****************************************************
;
;CodeWizardAVR V1.25.9 Professional  -   www.avr123.nm.ru
;
;Project : m48_ac_chip
;Version : 001
;Date    : 21.01.2009
;Author  : AVR123
;Company : avr123.nm.ru
;
;      - mc3phac   www.freescale.com
; ATmega48          .
;
; :
;
;  3-      3- .
;
; -     amp_sin  0  255
;   .
;
;================================================================================
;
;      3-  
;
; ""     PD6    OCR0A
; "B"     PD5    OCR0B
; "C"     PB3    OCR2A
;
;    !      PROTEUS    
;                "A" - PD6     "B" - PB3      "C" - PD5
;
;        
;  74hc14 (. 15532)
;
;   :    100 * (  )/255
;
;  0.5    128   
; 3- .    - 43
;
;=====================================================================
;
;1   4 -        2  
; OCR1A   interrupt [TIM1_COMPA]    
;  .
;
;  :
;
;1)   PB0   .
;
;2)       
;index_sin      inc_ind   
;    3- .
;
;..         
;     3-  .
;
;=====================================================================
; !!!
;
;     300  -   1  
;300*256=76800   .    8   9600   .
;
; 1   8,    OCR1A = 103; 
;  9615,385   .
;
;
;  .   OCR1AH = 0xFF;  OCR1AL = 0xFE; 
; 79132    12,64     ,   256
; - 0,049 .
;
;
;*****************************************************/
;
;// Declare your global variables here
;volatile char ctr;
;
;// volatile unsigned char temp = 0; //  
;
;
;volatile unsigned int index_sin = 0; //    
;
;volatile unsigned char index_a_sin = 0; //   A   
;volatile unsigned char index_b_sin = 0; //   B   
;
;
;volatile unsigned int temp_16; //   2 
;volatile unsigned char temp_8; //   1 
;
;volatile unsigned char temp_a; //     A
;volatile unsigned char temp_b; //     B
;
;volatile unsigned char pol_a = 1; //   A  "1" -  126

	.DSEG
;volatile unsigned char pol_b = 1; //   B  "0" -  128
;
;
;volatile unsigned char index_bc_calc = 1; // "1" -       
;
;volatile unsigned char  inc_ind = 1;  //     
;
;volatile unsigned int freq_int = 350; //   ,   103.
;
;volatile unsigned char amp_sin = 0; //  . 255  .
;
;// volatile unsigned char error_table = 0; //    
;
;// #define OCR1A (*(unsigned int *) 0x88) // 16 bit access
;//       OCR1A
;
;#include <mega48.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;#include <stdio.h>
;
;
;#include <sin256_1.h>
;/*    flash unsigned char sinus[256]={ };
;
;    3-  
;     3- 
;
;   0  255
;
;*/
;
;
;
;// Timer 1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 0080 {

	.CSEG
_timer1_compa_isr:
; .FSTART _timer1_compa_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0081 //     TCNT1=OCR1A
; 0000 0082 
; 0000 0083 PORTB^=1; //    PB0  //debug
	IN   R30,0x5
	LDI  R26,LOW(1)
	EOR  R30,R26
	OUT  0x5,R30
; 0000 0084 
; 0000 0085 //          .
; 0000 0086 
; 0000 0087 
; 0000 0088 
; 0000 0089 //============================================
; 0000 008A 
; 0000 008B 
; 0000 008C //============================================
; 0000 008D // . .     
; 0000 008E if (index_a_sin > 127){
	LDS  R26,_index_a_sin
	CPI  R26,LOW(0x80)
	BRLO _0x8
; 0000 008F            index_a_sin -= 128;
	LDS  R30,_index_a_sin
	SUBI R30,LOW(128)
	STS  _index_a_sin,R30
; 0000 0090 
; 0000 0091      index_bc_calc = 0; //        
	LDI  R30,LOW(0)
	STS  _index_bc_calc,R30
; 0000 0092 
; 0000 0093   if (pol_a){ //   
	LDS  R30,_pol_a
	CPI  R30,0
	BREQ _0x9
; 0000 0094                    pol_a = 0; pol_b = 0; PORTB ^=(1<< 1); PORTB ^=(1<< 2);
	LDI  R30,LOW(0)
	STS  _pol_a,R30
	STS  _pol_b,R30
	IN   R30,0x5
	LDI  R26,LOW(2)
	EOR  R30,R26
	OUT  0x5,R30
	IN   R30,0x5
	LDI  R26,LOW(4)
	EOR  R30,R26
	OUT  0x5,R30
; 0000 0095      index_b_sin = index_a_sin + 127;  //   90
	RJMP _0x19
; 0000 0096 
; 0000 0097             }
; 0000 0098     else{
_0x9:
; 0000 0099                    pol_a = 1; pol_b = 1;
	LDI  R30,LOW(1)
	STS  _pol_a,R30
	STS  _pol_b,R30
; 0000 009A      index_b_sin = index_a_sin + 127;   //   90
_0x19:
	LDS  R30,_index_a_sin
	SUBI R30,-LOW(127)
	STS  _index_b_sin,R30
; 0000 009B 
; 0000 009C         }
; 0000 009D                       }
; 0000 009E 
; 0000 009F //============================================
; 0000 00A0 //      B  
; 0000 00A1 if (index_bc_calc) {
_0x8:
	LDS  R30,_index_bc_calc
	CPI  R30,0
	BREQ _0xB
; 0000 00A2 
; 0000 00A3 //============================================
; 0000 00A4 //   .   B  
; 0000 00A5 if (index_b_sin > 127){
	LDS  R26,_index_b_sin
	CPI  R26,LOW(0x80)
	BRLO _0xC
; 0000 00A6            index_b_sin -= 128;
	LDS  R30,_index_b_sin
	SUBI R30,LOW(128)
	STS  _index_b_sin,R30
; 0000 00A7 
; 0000 00A8   if (pol_b){ //    B
	LDS  R30,_pol_b
	CPI  R30,0
	BREQ _0xD
; 0000 00A9                pol_b = 0; PORTB ^=(1<< 3); PORTB ^=(1<< 4);
	LDI  R30,LOW(0)
	STS  _pol_b,R30
	IN   R30,0x5
	LDI  R26,LOW(8)
	EOR  R30,R26
	OUT  0x5,R30
	IN   R30,0x5
	LDI  R26,LOW(16)
	EOR  R30,R26
	OUT  0x5,R30
; 0000 00AA             }
; 0000 00AB     else{
	RJMP _0xE
_0xD:
; 0000 00AC                 pol_b = 1;
	LDI  R30,LOW(1)
	STS  _pol_b,R30
; 0000 00AD         }
_0xE:
; 0000 00AE                       }
; 0000 00AF 
; 0000 00B0 }
_0xC:
; 0000 00B1 //============================================
; 0000 00B2 
; 0000 00B3 //          .
; 0000 00B4 
; 0000 00B5 //============================================
; 0000 00B6 //    
; 0000 00B7 
; 0000 00B8 
; 0000 00B9 //      . amp_sin    .
; 0000 00BA temp_8 = (((unsigned int)amp_sin * (unsigned int)sinus[index_a_sin])) >> 8;
_0xB:
	LDS  R26,_amp_sin
	CLR  R27
	LDS  R30,_index_a_sin
	LDI  R31,0
	SUBI R30,LOW(-_sinus*2)
	SBCI R31,HIGH(-_sinus*2)
	LPM  R30,Z
	LDI  R31,0
	RCALL __MULW12U
	MOV  R30,R31
	LDI  R31,0
	STS  _temp_8,R30
; 0000 00BB //    32  AVR
; 0000 00BC 
; 0000 00BD 
; 0000 00BE if (pol_a){ //    
	LDS  R30,_pol_a
	CPI  R30,0
	BREQ _0xF
; 0000 00BF               temp_a = temp_8 + 127; // PWM PD6 Faza_A
	LDS  R30,_temp_8
	SUBI R30,-LOW(127)
	RJMP _0x1A
; 0000 00C0           }
; 0000 00C1     else{   //    
_0xF:
; 0000 00C2               temp_a = 127 - temp_8;
	LDS  R26,_temp_8
	LDI  R30,LOW(127)
	SUB  R30,R26
_0x1A:
	STS  _temp_a,R30
; 0000 00C3         }
; 0000 00C4 
; 0000 00C5 //============================================
; 0000 00C6 //    B
; 0000 00C7 
; 0000 00C8 
; 0000 00C9 //      . amp_sin    .
; 0000 00CA temp_8 = (((unsigned int)amp_sin * (unsigned int)sinus[index_b_sin])) >> 8;
	LDS  R26,_amp_sin
	CLR  R27
	LDS  R30,_index_b_sin
	LDI  R31,0
	SUBI R30,LOW(-_sinus*2)
	SBCI R31,HIGH(-_sinus*2)
	LPM  R30,Z
	LDI  R31,0
	RCALL __MULW12U
	MOV  R30,R31
	LDI  R31,0
	STS  _temp_8,R30
; 0000 00CB //    32  AVR
; 0000 00CC 
; 0000 00CD 
; 0000 00CE if (pol_b){ //    
	LDS  R30,_pol_b
	CPI  R30,0
	BREQ _0x11
; 0000 00CF               temp_b = temp_8 + 127; // PWM PD6 Faza_A
	LDS  R30,_temp_8
	SUBI R30,-LOW(127)
	RJMP _0x1B
; 0000 00D0           }
; 0000 00D1     else{   //    
_0x11:
; 0000 00D2               temp_b = 127 - temp_8;
	LDS  R26,_temp_8
	LDI  R30,LOW(127)
	SUB  R30,R26
_0x1B:
	STS  _temp_b,R30
; 0000 00D3         }
; 0000 00D4 
; 0000 00D5 //=========================================================
; 0000 00D6 //         
; 0000 00D7 OCR0A = temp_a;  // PWM PD6 Faza_A
	LDS  R30,_temp_a
	OUT  0x27,R30
; 0000 00D8 OCR0B = temp_b;  // PWM PD5 Faza_B
	LDS  R30,_temp_b
	OUT  0x28,R30
; 0000 00D9 //=========================================================
; 0000 00DA //             
; 0000 00DB index_a_sin += inc_ind;  //   PWM PD6 Faza_A
	LDS  R30,_inc_ind
	LDS  R26,_index_a_sin
	ADD  R30,R26
	STS  _index_a_sin,R30
; 0000 00DC index_b_sin += inc_ind;  //   PWM PD5 Faza_B
	LDS  R30,_inc_ind
	LDS  R26,_index_b_sin
	ADD  R30,R26
	STS  _index_b_sin,R30
; 0000 00DD 
; 0000 00DE index_bc_calc = 1; //     
	LDI  R30,LOW(1)
	STS  _index_bc_calc,R30
; 0000 00DF temp_8 = 0; //debug
	LDI  R30,LOW(0)
	STS  _temp_8,R30
; 0000 00E0 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
;// ================================================================================
;//     
;//
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 00E6 {
_timer0_ovf_isr:
; .FSTART _timer0_ovf_isr
; 0000 00E7 }
	RETI
; .FEND
;
;// Timer 0 output compare A interrupt service routine
;interrupt [TIM0_COMPA] void timer0_compa_isr(void)
; 0000 00EB {
_timer0_compa_isr:
; .FSTART _timer0_compa_isr
; 0000 00EC }
	RETI
; .FEND
;
;// Timer 0 output compare B interrupt service routine
;interrupt [TIM0_COMPB] void timer0_compb_isr(void)
; 0000 00F0 {
_timer0_compb_isr:
; .FSTART _timer0_compb_isr
; 0000 00F1 }
	RETI
; .FEND
;
;//     
;// ================================================================================
;
;
;
;
;void main(void)
; 0000 00FA {
_main:
; .FSTART _main
; 0000 00FB 
; 0000 00FC // Function: Bit4=Out Bit3=Out Bit2=Out Bit1=Out
; 0000 00FD DDRB=( (1<<1) | (1<<2) | (1<<3) | (1<<4));
	LDI  R30,LOW(30)
	OUT  0x4,R30
; 0000 00FE // State: Bit4=1 Bit3=1 Bit2=0 Bit1=0
; 0000 00FF PORTB=(1<<1) | (0<<2) | (1<<3) | (0<<4);
	LDI  R30,LOW(10)
	OUT  0x5,R30
; 0000 0100 
; 0000 0101 
; 0000 0102 // Declare your local variables here
; 0000 0103 
; 0000 0104 // Crystal Oscillator division factor: 1
; 0000 0105 #pragma optsize-
; 0000 0106 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0107 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0108 #ifdef _OPTIMIZE_SIZE_
; 0000 0109 #pragma optsize+
; 0000 010A #endif
; 0000 010B 
; 0000 010C DDRB.0 = 1; //  
	SBI  0x4,0
; 0000 010D 
; 0000 010E // =============================================================
; 0000 010F //  _0  - 2     ""  ""
; 0000 0110 // Timer/Counter 0 initialization
; 0000 0111 // Clock source: System Clock
; 0000 0112 // Clock value: 8000 kHz  
; 0000 0113 // Mode: Phase correct PWM top=FFh    15 686 Hz
; 0000 0114 // OC0A output: Non-Inverted PWM
; 0000 0115 // OC0B output: Non-Inverted PWM
; 0000 0116 TCCR0A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x24,R30
; 0000 0117 TCCR0B=0x01;
	LDI  R30,LOW(1)
	OUT  0x25,R30
; 0000 0118 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0119 
; 0000 011A 
; 0000 011B 
; 0000 011C //      50 %   
; 0000 011D 
; 0000 011E OCR0A=127; // PWM PD6 Faza_A   100 * OCR0A/255  ( %)
	LDI  R30,LOW(127)
	OUT  0x27,R30
; 0000 011F OCR0B=127; // PWM PD5 Faza_B   100 * OCR0B/255  ( %)
	OUT  0x28,R30
; 0000 0120 
; 0000 0121 
; 0000 0122 //   
; 0000 0123 DDRD|=(1<<5)|(1<<6); // PD5 PD6    0
	IN   R30,0xA
	ORI  R30,LOW(0x60)
	OUT  0xA,R30
; 0000 0124 
; 0000 0125 
; 0000 0126 
; 0000 0127 // =============================================================
; 0000 0128 //TIMER1 initialize - prescale:8
; 0000 0129 // WGM: 4) CTC, TOP=OCRnA
; 0000 012A // desired value: 9600Hz
; 0000 012B // actual value: 9615,385Hz   OCR1A = 103;
; 0000 012C 
; 0000 012D  TCCR1B = 0x00; //stop
	LDI  R30,LOW(0)
	STS  129,R30
; 0000 012E 
; 0000 012F   //    8    PROTEUS
; 0000 0130  OCR1AH = (unsigned char)(freq_int >> 8);
	LDS  R30,_freq_int+1
	STS  137,R30
; 0000 0131  OCR1AL = (unsigned char)freq_int;
	LDS  R30,_freq_int
	STS  136,R30
; 0000 0132 
; 0000 0133 
; 0000 0134  TCCR1A = 0x00;
	LDI  R30,LOW(0)
	STS  128,R30
; 0000 0135  TCCR1B = 0x0A; //start Timer
	LDI  R30,LOW(10)
	STS  129,R30
; 0000 0136 
; 0000 0137 
; 0000 0138 // =============================================================
; 0000 0139 // External Interrupt(s) initialization
; 0000 013A // INT0: Off
; 0000 013B // INT1: Off
; 0000 013C // Interrupt on any change on pins PCINT0-7: Off
; 0000 013D // Interrupt on any change on pins PCINT8-14: Off
; 0000 013E // Interrupt on any change on pins PCINT16-23: Off
; 0000 013F EICRA=0x00;
	LDI  R30,LOW(0)
	STS  105,R30
; 0000 0140 EIMSK=0x00;
	OUT  0x1D,R30
; 0000 0141 PCICR=0x00;
	STS  104,R30
; 0000 0142 
; 0000 0143 // Timer/Counter 0 Interrupt(s) initialization
; 0000 0144 TIMSK0=0x07;
	LDI  R30,LOW(7)
	STS  110,R30
; 0000 0145 
; 0000 0146 // Timer/Counter 1 Interrupt(s) initialization
; 0000 0147 TIMSK1=0x02;
	LDI  R30,LOW(2)
	STS  111,R30
; 0000 0148 
; 0000 0149 // Timer/Counter 2 Interrupt(s) initialization
; 0000 014A TIMSK2=0x00;
	LDI  R30,LOW(0)
	STS  112,R30
; 0000 014B 
; 0000 014C // Global enable interrupts
; 0000 014D #asm("sei")
	sei
; 0000 014E 
; 0000 014F while (1)
_0x15:
; 0000 0150       {
; 0000 0151       // Place your code here
; 0000 0152 
; 0000 0153     amp_sin = 250; //debug
	LDI  R30,LOW(250)
	STS  _amp_sin,R30
; 0000 0154 
; 0000 0155 //    
; 0000 0156 //
; 0000 0157 // while (ctr < 254){
; 0000 0158 //
; 0000 0159 // delay_ms(3);
; 0000 015A //
; 0000 015B // amp_sin = ctr ++;
; 0000 015C //
; 0000 015D // };
; 0000 015E //
; 0000 015F //
; 0000 0160 // while (ctr){
; 0000 0161 //
; 0000 0162 // delay_ms(3);
; 0000 0163 //
; 0000 0164 // amp_sin = ctr --;
; 0000 0165 //
; 0000 0166 // };
; 0000 0167 //
; 0000 0168     };
	RJMP _0x15
; 0000 0169 }
_0x18:
	RJMP _0x18
; .FEND
;
;
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_index_a_sin:
	.BYTE 0x1
_index_b_sin:
	.BYTE 0x1
_temp_8:
	.BYTE 0x1
_temp_a:
	.BYTE 0x1
_temp_b:
	.BYTE 0x1
_pol_a:
	.BYTE 0x1
_pol_b:
	.BYTE 0x1
_index_bc_calc:
	.BYTE 0x1
_inc_ind:
	.BYTE 0x1
_freq_int:
	.BYTE 0x2
_amp_sin:
	.BYTE 0x1

	.CSEG

	.CSEG
__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

;END OF CODE MARKER
__END_OF_CODE:
